//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "skintest.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSkinTestWnd *SkinTestWnd;
//---------------------------------------------------------------------------
__fastcall TSkinTestWnd::TSkinTestWnd(TComponent* Owner)
    : TForm(Owner)
{
    enforceRatio=0;
    lcdBmp=new Graphics::TBitmap;
    lcdBmp->Width=480;
    lcdBmp->Height=256;
    lcdBmp->PixelFormat=pf24bit;
    sLcdBmp=new Graphics::TBitmap;
    sLcdBmp->Width=240;
    sLcdBmp->Height=128;
    sLcdBmp->PixelFormat=pf24bit;
}
//---------------------------------------------------------------------------
void __fastcall TSkinTestWnd::WMSizing(TMessage &Msg)
{
    RECT *r=(LPRECT)Msg.LParam;
    if (!enforceRatio)
    {
        Msg.Result=false;
        return;
    }
    Normal1xview1->Checked=false;
    Large2xview1->Checked=false;
    int cliW=r->right-r->left-(Width-ClientWidth);
    int cliH=r->bottom-r->top-(Height-ClientHeight);
    int newW=Image->Picture->Bitmap->Width*cliH/Image->Picture->Bitmap->Height;
    int newH=Image->Picture->Bitmap->Height*cliW/Image->Picture->Bitmap->Width;
    newW+=(Width-ClientWidth);
    newH+=(Height-ClientHeight);
    int dx=abs(newW-(r->right-r->left));
    int dy=abs(newH-(r->bottom-r->top));
    if ((dx>=dy)||(Msg.WParam==WMSZ_LEFT)||(Msg.WParam==WMSZ_RIGHT))
    {
        if (newH<GetSystemMetrics(SM_CYMIN))
            GetWindowRect(Handle,r);
        else
        {
            if ((Msg.WParam==WMSZ_TOP)||
                (Msg.WParam==WMSZ_TOPLEFT)||
                (Msg.WParam==WMSZ_TOPRIGHT))
                r->top=r->bottom-newH;
            else
                r->bottom=r->top+newH;
        }
    }
    else
    {
        if (newW<GetSystemMetrics(SM_CXMIN))
            GetWindowRect(Handle,r);
        else
        {
            if ((Msg.WParam==WMSZ_BOTTOMLEFT)||
                (Msg.WParam==WMSZ_LEFT)||
                (Msg.WParam==WMSZ_TOPLEFT))
                r->left=r->right-newW;
            else
                r->right=r->left+newW;
        }
    }
    Image->Width=r->right-r->left-(Width-ClientWidth);
    Image->Height=r->bottom-r->top-(Height-ClientHeight);
    PaintBox->Left=lcd.Left*Image->Width/Image->Picture->Bitmap->Width;
    PaintBox->Width=(lcd.Right-lcd.Left)*Image->Width/Image->Picture->Bitmap->Width;
    PaintBox->Top=lcd.Top*Image->Height/Image->Picture->Bitmap->Height;
    PaintBox->Height=(lcd.Bottom-lcd.Top)*Image->Height/Image->Picture->Bitmap->Height;
    Msg.Result=true;
}

void __fastcall TSkinTestWnd::PaintBoxPaint(TObject *Sender)
{
    TRect r;
    r.Left=0; r.Right=PaintBox->Width;
    r.Top=0; r.Bottom=PaintBox->Height;
    if (r.Right>sLcdBmp->Width)
        PaintBox->Canvas->StretchDraw(r,lcdBmp);
    else
        PaintBox->Canvas->StretchDraw(r,sLcdBmp);
}
//---------------------------------------------------------------------------

void __fastcall TSkinTestWnd::Normal1xview1Click(TObject *Sender)
{
    enforceRatio=0;
    ClientWidth=Image->Picture->Bitmap->Width>>1;
    ClientHeight=Image->Picture->Bitmap->Height>>1;
    Image->Width=Image->Picture->Bitmap->Width>>1;
    Image->Height=Image->Picture->Bitmap->Height>>1;
    PaintBox->Left=lcd.Left*Image->Width/Image->Picture->Bitmap->Width;
    PaintBox->Width=sLcdBmp->Width;
    PaintBox->Top=lcd.Top*Image->Height/Image->Picture->Bitmap->Height;
    PaintBox->Height=sLcdBmp->Height;
    Normal1xview1->Checked=true;
    Large2xview1->Checked=false;
    enforceRatio=1;
}
//---------------------------------------------------------------------------

void __fastcall TSkinTestWnd::Large2xview1Click(TObject *Sender)
{
    enforceRatio=0;
    ClientWidth=Image->Picture->Bitmap->Width;
    ClientHeight=Image->Picture->Bitmap->Height;
    Image->Width=Image->Picture->Bitmap->Width;
    Image->Height=Image->Picture->Bitmap->Height;
    PaintBox->Left=lcd.Left*Image->Width/Image->Picture->Bitmap->Width;
    PaintBox->Width=lcdBmp->Width;
    PaintBox->Top=lcd.Top*Image->Height/Image->Picture->Bitmap->Height;
    PaintBox->Height=lcdBmp->Height;
    Normal1xview1->Checked=false;
    Large2xview1->Checked=true;
    enforceRatio=1;
}
//---------------------------------------------------------------------------

